@class NSData;

#define TCDataScannerCStringUnbounded 0
#define TCDataScannerStringUnbounded 0

@interface TCDataScanner : NSObject
{
    NSData *_data;
    const unsigned char *_bytes;
    unsigned _offset;
    enum NSByteOrder _order;
}

+ (TCDataScanner *)scannerWithData:(NSData *)data;

- (id)initWithData:(NSData *)data;

- (unsigned)offset;
- (void)setOffset:(unsigned)offset;
- (void)advanceOffsetBy:(unsigned)delta;

- (enum NSByteOrder)byteOrder;
- (void)setByteOrder:(enum NSByteOrder)order;

- (unsigned)remainingBytes;

- (BOOL)matchString:(NSString *)string length:(unsigned)length encoding:(NSStringEncoding)encoding;
- (NSString *)scanStringOfLength:(unsigned)length encoding:(NSStringEncoding)encoding;

- (BOOL)matchCString:(const char *)cString length:(unsigned)length;
- (const char *)scanCStringOfLength:(unsigned)length;

- (BOOL)matchByte:(unsigned char)byte;
- (unsigned char)scanByte;

- (BOOL)matchShort:(unsigned short)aShort;
- (unsigned short)scanShort;

- (BOOL)matchLong:(unsigned long)aLong;
- (unsigned long)scanLong;

@end
